#!/usr/bin/perl -w
#
#  This code reads from the changedfiles via a syscall and expands 
#  filename parameters. 
#
use strict;
sub expand_file($$) {
  my ($pid, $file)=@_;
  return $file if $file =~ m:^/:;
  my $cwd=`cd /proc/$pid/cwd && /usr/bin/pwd`;
  chomp($cwd);
  my $full_file="$cwd/$file";
  return $full_file;
}

sub expand_fd($$) {
  my ($pid, $fd)=@_;
  # Figure out how to do. Can crib from lsof perhaps.
  return ;
}

sub process_line($) {
  if ( $_[0] !~ /^(\d) (\d+) (\S+)\s+(.*)$/) {
    print STDERR "Bad line: $_[0]\n";
    return 0;
  }
  my($rc, $pid, $op, $rest)=($1, $2, $3, $4);

  if ($op =~ m/MKDIR|RMDIR/) {
    my $fullfile=expand_file($pid, $rest);
    print "$op $fullfile\n";
  }
  return 1
}

my $EMPTY_LINE = '\0' x 300;
my $done=0;
while ( !$done ) {
  my $string= $EMPTY_LINE;
  if (syscall(182, $string)) {
    print STDERR "Error reading...\n";
  } else {
    my ($line)=split(/\0/, $string) ;
    process_line $line if $line ne $EMPTY_LINE;
  }
  printf "loop...\n";
}
